﻿using System;
using System.Windows;

namespace WpfAsyncMessageBox
{
	public partial class Window1 : Window
	{
		public Window1()
		{
			InitializeComponent();
		}

		private void buttonEveryTime_Click( object sender, RoutedEventArgs e )
		{
			AsyncMessageBox.BeginMessageBoxAsync( 
                "This message box will be created for each Every Time click.",
                "Repeated Message Box",
                MessageBoxButton.OK,
                MessageBoxImage.Information );
		}

		private IAsyncResult m_asyncResultOneAtATime;

		private void buttonOneAtATime_Click( object sender, RoutedEventArgs e )
		{
			AsyncMessageBox.BeginMessageBoxAsync( "This message box will not be re-created until it is closed.",
                "Non-Repeated Message Box",
                MessageBoxButton.OK,
                MessageBoxImage.Information,
                ref m_asyncResultOneAtATime,
                new AsyncCallback( ProcessMessageBoxAsync ) );
		}

        private void buttonYesNo_Click( object sender, RoutedEventArgs e )
        {
            AsyncCallback callBack = new AsyncCallback( ProcessMessageBoxAsync );

            AsyncMessageBox.BeginMessageBoxAsync( "This message box will not be re-created until it is closed.",
                "Yes/No Non-Repeated Message Box",
                MessageBoxButton.YesNoCancel,
                MessageBoxImage.Error,
                ref m_asyncResultOneAtATime,
                new AsyncCallback( ProcessMessageBoxAsync ) );
        }

        private void ProcessMessageBoxAsync( IAsyncResult result )
        {
            MessageBox.Show( "Async Message Box result: " + AsyncMessageBox.EndMessageBoxAsync( result ).ToString(), "Async Result" );
        }
	}
}
